#include <OneWire.h>
#include <DallasTemperature.h>
#include <math.h>
int denatTime;          //Denaturation Time
int denatTemp;          //Denaturation Temp
int annealTime;
int annealTemp;
int extendTime;
int extendTemp;
int cycles;
unsigned long now = millis ();
int heater = 7; // D7 Pin to turn on Relay
int time = 0;   // Time counter for cycle timing
int cycle = 0;  // Cycle counter
 
// Data wire is plugged into pin 2 on the Arduino
#define ONE_WIRE_BUS 2
 
// Setup a oneWire instance to communicate with any OneWire devices 
// (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);
 
// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);
 
void setup(void)
{
  Serial.begin(9600);
  sensors.begin();
  pinMode(heater, OUTPUT);  // Set Pin connected to Relay as an OUTPUT
  digitalWrite(heater, LOW);  // Set Pin to LOW to turn Relay OFF
}

void loop(void)
{
  Serial.println("Enter the denaturation time in seconds ");        //Prompt User for input
  while (Serial.available()==0)  {  
  }
  denatTime=Serial.parseInt();  
  Serial.println(denatTime);                                        //Read user input into age
  
  Serial.println("Enter the denaturation temp in Celsius "); 
  now = millis ();
  while (millis () - now < 1000)
  Serial.read ();  // read and discard any input
  
  while (Serial.available()==0)  {  
  }
  denatTemp=Serial.parseInt();                                      //Read user input into age
  Serial.println(denatTemp);  

  Serial.println("Enter the annealing time in seconds "); 
  now = millis ();
  while (millis () - now < 2000)
  Serial.read ();  // read and discard any input
  
  while (Serial.available()==0)  {  
  }
  annealTime=Serial.parseInt();                                      //Read user input into age
  Serial.println(annealTime);  

  Serial.println("Enter the annealing temp in Celsius "); 
  now = millis ();
  while (millis () - now < 1000)
  Serial.read ();  // read and discard any input
  
  while (Serial.available()==0)  {  
  }
  annealTemp=Serial.parseInt();                                      //Read user input into age
  Serial.println(annealTemp);  

  Serial.println("Enter the extension time in seconds "); 
  now = millis ();
  while (millis () - now < 1000)
  Serial.read ();  // read and discard any input
  
  while (Serial.available()==0)  {  
  }
  extendTime=Serial.parseInt();                                      //Read user input into age
  Serial.println(extendTime);  

  Serial.println("Enter the extension temp in Celsius "); 
  now = millis ();
  while (millis () - now < 1000)
  Serial.read ();  // read and discard any input
  
  while (Serial.available()==0)  {  
  }
  extendTemp=Serial.parseInt();                                      //Read user input into age
  Serial.println(extendTemp);
  Serial.println("Enter the number of cycles "); 
  now = millis ();
  while (millis () - now < 1000)
  Serial.read ();  // read and discard any input
  
  while (Serial.available()==0)  {  
  }
  cycles=Serial.parseInt();                                      //Read user input into age
  Serial.println(cycles);

  sensors.requestTemperatures(); // Send the command to get temperatures
  Serial.println("#########");
  Serial.println("Warming up.");
  Serial.println("This may take several minutes.");
  Serial.println("#########");
  //Serial.print(denatTemp);
  //Serial.println("C");
  
  while (sensors.getTempCByIndex(0) < denatTemp) {      //***95*** While Loop to Bring up to Temp - 95C                  
    sensors.requestTemperatures(); // Send the command to get temperatures
    //Serial.print("Temperature is: ");
    //Serial.println(sensors.getTempCByIndex(0));
    digitalWrite(heater, HIGH);
    delay(1000);
  }
    
//Phase 1: Stay at 95C for 120 sec
  Serial.println("Intialization Phase (120 sec).");
  while ( time < 120) {  // ***Set to 121*** While Loop to keep temp at 95C for 120 seconds         
    
    //Serial.print(denatTemp);
    //Serial.println(" Celsius");
    //Serial.println(time);
    time = time + 1;
    delay(1000);
    sensors.requestTemperatures();
    if (sensors.getTempCByIndex(0) > denatTemp) {                                                                         
         digitalWrite(heater, LOW);
      //   Serial.print(">");
      //   Serial.println(denatTemp);
      //   Serial.println(sensors.getTempCByIndex(0));
                                          }                                                                       
    else {                                                                         
         digitalWrite(heater, HIGH);
        // Serial.print("<");
        // Serial.print(denatTemp);
        // Serial.println(sensors.getTempCByIndex(0));
         }                                                                        
  }   
  
//Cycle Counter
while (cycle < cycles) {
  cycle = cycle + 1;
  Serial.println("#########");
  Serial.print(cycle);
  Serial.print(" of ");
  Serial.print(cycles);
  Serial.println(" cycles");
//Phase 2: 95C for 15 sec Cycle  
  time=0;
  //Serial.println("########");
  //Serial.print("Temp ");
  Serial.print(denatTemp);
  Serial.print("C for ");
  Serial.print(denatTime);
  Serial.println(" seconds");
  //Serial.println("########");
  while ( time <denatTime) {   // Hold at 95C for 15 sec.
    //Serial.print("Phase 2: Hold at ");
    //Serial.print(denatTemp);
    //Serial.print("C for ");
    //Serial.print(time);
    //Serial.println(" seconds");
    time = time + 1;
    delay(1000);
    sensors.requestTemperatures();
    if (sensors.getTempCByIndex(0) > denatTemp) {                                                                         
         digitalWrite(heater, LOW);
      //   Serial.print(">");
      //   Serial.println(denatTemp);
      //   Serial.println(sensors.getTempCByIndex(0));
                                          }                                                                       
    else {                                                                         
         digitalWrite(heater, HIGH);
        // Serial.print("<");
        // Serial.println(denatTemp);
        // Serial.println(sensors.getTempCByIndex(0));
         }                                                                        
  }   
 
//Phase 3: Drop Temp to 55C  
  
  sensors.requestTemperatures(); // Send the command to get temperatures
  //Serial.println("########");
  //Serial.print("Phase 3: Set to ");
  //Serial.print(annealTemp);
  //Serial.println("C");

  while (sensors.getTempCByIndex(0) > annealTemp) {      //***55*** While Loop to Drop Temp - 55C                  
    sensors.requestTemperatures(); // Send the command to get temperatures
   // Serial.print("Temperature is: ");
   // Serial.println(sensors.getTempCByIndex(0));
    digitalWrite(heater, LOW);
    delay(1000);
  }

//Phase 4: 55C for 15 sec Cycle  
  //Serial.println("########");
  //Serial.print("Phase 4: Hold at ");
  Serial.print(annealTemp);
  Serial.print("C for ");
  Serial.print(annealTime);
  Serial.println(" seconds");
  //Serial.println("########");
  time=0;
  while ( time < annealTime) {   // Hold at 55C for 15 sec.
  // Serial.print("Phase 4: Hold at ");
  //  Serial.print(annealTemp);
  //  Serial.print(" for ");
  //  Serial.print(annealTime);
  //  Serial.println("seconds");
  //  Serial.println(time);
    time = time + 1;
    delay(1000);
    sensors.requestTemperatures();
    if (sensors.getTempCByIndex(0) > 55) {                                                                         
         digitalWrite(heater, LOW);
         //Serial.print(">");
         //Serial.print(annealTemp);
         //Serial.println(" Celsius");
         //Serial.println(sensors.getTempCByIndex(0));
                                          }                                                                       
    else {                                                                         
         digitalWrite(heater, HIGH);\
         //Serial.print("< ");
         //Serial.println(annealTemp);
         //Serial.println(" Celsius");
         //Serial.println(sensors.getTempCByIndex(0));
         }                                                                        
  }   


//Phase 5: Increase Temp to 68C  
  
  sensors.requestTemperatures(); // Send the command to get temperatures
  //Serial.println("########");
  //Serial.print("Phase 5: Set to ");
  //Serial.print(extendTemp);
  //Serial.println("C");

  while (sensors.getTempCByIndex(0) < extendTemp) {      //***68*** While Loop to Bring up to Temp - 68C                  
    sensors.requestTemperatures(); // Send the command to get temperatures
    //Serial.print("Temperature is: ");
    //Serial.println(sensors.getTempCByIndex(0));
    digitalWrite(heater, HIGH);
    delay(1000);
  }

//Phase 6: 68C for 15 sec Cycle  
  //Serial.println("########");
  //Serial.print("Phase 6: Hold at ");
  Serial.print(extendTemp);
  Serial.print("C for ");
  Serial.print(extendTime);
  Serial.println(" seconds");
  //Serial.println("########");
  time=0;
  while ( time < extendTime) {   // Hold at 68C for 45 sec.
    //Serial.print("Phase 6: Hold at ");
    //Serial.print(extendTemp);
    //Serial.println(" Celsius");
    //Serial.println(time);
    time = time + 1;
    delay(1000);
    sensors.requestTemperatures();
    if (sensors.getTempCByIndex(0) > extendTemp) {                                                                         
         digitalWrite(heater, LOW);
         //Serial.print(">");
         //Serial.println(extendTemp);
         //Serial.println(sensors.getTempCByIndex(0));
                                          }                                                                       
    else {                                                                         
         digitalWrite(heater, HIGH);
        // Serial.print("< ");
        // Serial.println(extendTemp);
        // Serial.println(sensors.getTempCByIndex(0));
         }                                                                        
  }   

//Phase 7: Increase Temp to 95C  
  
  sensors.requestTemperatures(); // Send the command to get temperatures
  //Serial.println("########");
  //Serial.print("Phase 7: Set to ");
  //Serial.print(denatTemp);
  //Serial.print("C");

  while (sensors.getTempCByIndex(0) < denatTemp) {      //***95*** While Loop to Bring up to Temp - 95C                  
    sensors.requestTemperatures(); // Send the command to get temperatures
    //Serial.print("Temperature is: ");
    //Serial.println(sensors.getTempCByIndex(0));
    digitalWrite(heater, HIGH);
    delay(1000);
  }
}
    
digitalWrite(heater, LOW);  // Set Pin to LOW to turn Relay OFF
Serial.println();
Serial.println("###############");
Serial.println("   Completed");
Serial.println();
digitalWrite(heater, LOW);
while(true);


}
